#include <stdio.h>
#include <math.h>
#include <malloc.h>

#define Stream           FILE *
#define Stream_open(n,m) fopen(n,m)
#define Stream_close(f)  fclose(f)
#define Stream_get(f)    fgetc(f)

#define null  0
#define true  1
#define false 0

#define getMem(a)        malloc(a)
#define freeMem(a)       free(a)

#define XML_OPEN   1
#define XML_CLOSE  2
#define XML_TEXT   4

 typedef struct _XMLmin_ *XMLmin;

 struct _XMLmin_
{
 Stream f;
 char *txt;
 int l;
 int tag;
 int level;
 int (*processTag)(XMLmin xml);
 int sp;
 void **stack;
 void *object;
 char tagname[64];
 };
 
 XMLmin new_XMLmin(int l,int st);

 XMLmin nul_XMLmin(XMLmin xml);

 int XML_attribute(XMLmin xml,char *str);

 int XML_isTag(XMLmin xml,char *str);

 int XML_getTag(XMLmin xml);

 int XML_getText(XMLmin xml);

 int XML_getInt(XMLmin xml,char *att,int def);

 double XML_getDouble(XMLmin xml,char *att,double def);

 float XML_getFloat(XMLmin xml,char *att,float def);

 int XML_getString(XMLmin xml,char *att,char *str);

 int XML_getArrayLength(XMLmin xml,char *att);

 int XML_getIntArray(XMLmin xml,char *att,int *a,int len);

 int XML_getFloatArray(XMLmin xml,char *att,float *a,int len);

 int XML_get(XMLmin xml);

 void  XML_push(XMLmin xml,void *p);

 void *XML_pop(XMLmin xml);

 void XML_stream(XMLmin xml,Stream stream);

